Index: mpeg2fix.cpp
===================================================================
--- mpeg2fix.cpp	(revision 18755)
+++ mpeg2fix.cpp	(working copy)
@@ -27,6 +27,8 @@
 #define O_LARGEFILE 0
 #endif
 
+#define DEBUG_AUDIO 1
+
 #define ATTR_ALIGN(align) __attribute__ ((__aligned__ (align)))
 
 #define SHOW_MSG(msg) (msg & print_verbose_messages)
@@ -237,6 +239,7 @@
     }
 
     ext_count = 0;
+    ac3_count = 0;
     vid_id = -1;
     mpeg2_malloc_hooks(my_malloc, NULL);
     header_decoder = mpeg2_init();
@@ -452,7 +455,10 @@
     memset(&index_vrbuf, 0, sizeof(ringbuffer));
     memset(&extrbuf, 0, sizeof(ringbuffer) * N_AUDIO);
     memset(&index_extrbuf, 0, sizeof(ringbuffer) * N_AUDIO);
+    memset(&ac3extrbuf, 0, sizeof(ringbuffer) * N_AUDIO);
+    memset(&index_ac3extrbuf, 0, sizeof(ringbuffer) * N_AUDIO);
     ext_count = 0;
+    ac3_count = 0;
 }
 
 MPEG2replex::~MPEG2replex()
@@ -485,6 +491,10 @@
             if (ring_avail(&index_extrbuf[i]) < sizeof(index_unit))
                 ok = 0;
 
+        for (i = 0; i < ac3_count; i++)
+            if (ring_avail(&index_ac3extrbuf[i]) < sizeof(index_unit))
+                ok = 0;
+
         if (ok || done)
             break;
 
@@ -518,6 +528,7 @@
     // note that although only 1 stream is currently supported, multiplex.c
     // expects the size to by N_AUDIO
     int ext_ok[N_AUDIO];
+    int ac3_ok[N_AC3];
     int video_ok = 0;
 
     //seq_head should be set only for the 1st sequence header.  If a new
@@ -529,6 +540,7 @@
 
     memset(&mx, 0, sizeof(mx));
     memset(ext_ok, 0, sizeof(ext_ok));
+    memset(ac3_ok, 0, sizeof(ac3_ok));
 
     mx.priv = (void *)this;
 
@@ -541,16 +553,27 @@
     pthread_mutex_unlock(&mutex);
 
     mplex = &mx;
-
+/*
     init_multiplex(&mx, &seq_head, extframe, exttype, exttypcnt,
                    video_delay, audio_delay, fd_out, fill_buffers,
                    &vrbuf, &index_vrbuf, extrbuf, index_extrbuf, otype);
+*/
+    init_multiplex(&mx, &seq_head, extframe, ac3frame, ext_count /*audio pids */, ac3_count /* ac3 streams */,
+                   video_delay, audio_delay, fd_out, fill_buffers,
+                   &vrbuf, &index_vrbuf, extrbuf, index_extrbuf,
+                   ac3extrbuf, index_ac3extrbuf,
+		   otype);
+
+    VERBOSE(MPF_RPLXQUEUE, QString("  Finished:  init_multiplex "));
     setup_multiplex(&mx);
+    VERBOSE(MPF_RPLXQUEUE, QString("  Finished:  setup_multiplex "));
 
     while (1)
     {
-        check_times( &mx, &video_ok, ext_ok, &start);
-        write_out_packs( &mx, video_ok, ext_ok);
+        check_times( &mx, &video_ok, ext_ok, ac3_ok, &start);
+        VERBOSE(MPF_RPLXQUEUE, QString("  vid_ok: %1 ext_ok: %2  ac3_ok: %3  ")
+			.arg(video_ok).arg(ext_ok[0]).arg(ac3_ok[0]));
+        write_out_packs( &mx, video_ok, ext_ok, ac3_ok);
     }
 }
 
@@ -569,28 +592,29 @@
 
     memset(rx.exttype, 0, sizeof(rx.exttype));
     memset(rx.exttypcnt, 0, sizeof(rx.exttypcnt));
-    int mp2_count = 0, ac3_count = 0;
     for (QMap<int, Q3PtrList<MPEG2frame> >::iterator it = aFrame.begin();
             it != aFrame.end(); it++)
     {
         int i = aud_map[it.key()];
         char *lang = inputFC->streams[it.key()]->language;
-        ring_init(&rx.extrbuf[i], memsize / 5);
-        ring_init(&rx.index_extrbuf[i], INDEX_BUF);
-        rx.extframe[i].set = 1;
-        rx.extframe[i].bit_rate = getCodecContext(it.key())->bit_rate;
-        rx.extframe[i].framesize = it.data().first()->pkt.size;
-        strncpy(rx.extframe[i].language, lang, 4);
         switch(GetStreamType(it.key()))
         {
             case CODEC_ID_MP2:
             case CODEC_ID_MP3:
-                rx.exttype[i] = 2;
-                rx.exttypcnt[i] = mp2_count++;
+                ring_init(&rx.extrbuf[i], memsize / 5);
+                ring_init(&rx.index_extrbuf[i], INDEX_BUF);
+                memset(&rx.extframe[i], 0, sizeof(audio_frame_t));
+                rx.extframe[i].set = 1;
+                rx.extframe[i].bit_rate = getCodecContext(it.key())->bit_rate;
+                rx.extframe[i].framesize = it.data().first()->pkt.size;
                 break;
             case CODEC_ID_AC3:
-                rx.exttype[i] = 1;
-                rx.exttypcnt[i] = ac3_count++;
+                ring_init(&rx.ac3extrbuf[i], memsize / 5);
+                ring_init(&rx.index_ac3extrbuf[i], INDEX_BUF);
+                memset(&rx.ac3frame[i], 0, sizeof(audio_frame_t));
+                rx.ac3frame[i].set = 1;
+                rx.ac3frame[i].bit_rate = getCodecContext(it.key())->bit_rate;
+                rx.ac3frame[i].framesize = it.data().first()->pkt.size;
                 break;
         }
     }
@@ -601,6 +625,7 @@
                          26999999ULL) / vFrame.first()->mpeg2_seq.frame_period;
 
     rx.ext_count = ext_count;
+    rx.ac3_count = ac3_count;
 }
 
 void MPEG2fixup::FrameInfo(MPEG2frame *f)
@@ -616,6 +641,13 @@
             msg += QString(" %2")
                    .arg(ring_free(&rx.index_extrbuf[i]) / sizeof(index_unit));
     }
+    if (ac3_count)
+    {
+        msg += " AC3:";
+        for (int i = 0; i < ac3_count; i++)
+            msg += QString(" %2")
+                   .arg(ring_free(&rx.index_ac3extrbuf[i]) / sizeof(index_unit));
+    }
     VERBOSE(MPF_RPLXQUEUE, msg);
 }
 
@@ -640,9 +672,17 @@
         iu.frame_off = f->framePos - f->pkt.data;
         iu.dts = f->pkt.dts * 300;
     }
+    else if (GetStreamType(id) == CODEC_ID_AC3)
+    {
+        //VERBOSE(MPF_IMPORTANT, QString("Ringbuffer AC3 stream: %1 aud_map: %2 size: %3 "
+        //                           ).arg(id).arg(aud_map[id]).arg(f->pkt.size));
+        rb = &rx.ac3extrbuf[aud_map[id]];
+        rbi = &rx.index_ac3extrbuf[aud_map[id]];
+        iu.framesize = f->pkt.size;
+    }
     else if (GetStreamType(id) == CODEC_ID_MP2 ||
-             GetStreamType(id) == CODEC_ID_MP3 ||
-             GetStreamType(id) == CODEC_ID_AC3)
+             GetStreamType(id) == CODEC_ID_MP3 /* ||
+             GetStreamType(id) == CODEC_ID_AC3 */)
     {
         rb = &rx.extrbuf[aud_map[id]];
         rbi = &rx.index_extrbuf[aud_map[id]];
@@ -675,6 +715,11 @@
                     ring_avail(&rx.index_extrbuf[i]) < sizeof(index_unit))
                 ok = 0;
 
+        for (i = 0; i < ac3_count; i++)
+            if (rbi != &rx.index_ac3extrbuf[i] &&
+                    ring_avail(&rx.index_ac3extrbuf[i]) < sizeof(index_unit))
+                ok = 0;
+
         if (! ok && ring_free(rb) < (unsigned int)f->pkt.size &&
                     ring_free(rbi) >= sizeof(index_unit))
         {
@@ -682,8 +727,8 @@
             unsigned int inc_size = 10*(unsigned int)f->pkt.size;
             VERBOSE(MPF_IMPORTANT, QString("Increasing ringbuffer size by %1 "
                                    "to avoid deadlock").arg(inc_size));
-            if (! ring_reinit(rb, rb->size + inc_size))
-                ok = 1;
+            //if (! ring_reinit(rb, rb->size + inc_size))
+            //    ok = 1;
         }
         if (! ok)
         {
@@ -777,7 +822,12 @@
                             "Skipping invalid audio stream: %1").arg(i));
                     break;
                 }
-                if (inputFC->streams[i]->codec->codec_id == CODEC_ID_AC3 ||
+                if (inputFC->streams[i]->codec->codec_id == CODEC_ID_AC3)
+	        {
+                    aud_map[i] = ac3_count++;
+                    aFrame[i] = Q3PtrList<MPEG2frame> ();
+		}
+		else if (/* inputFC->streams[i]->codec->codec_id == CODEC_ID_AC3 || */
                     inputFC->streams[i]->codec->codec_id == CODEC_ID_MP3 ||
                     inputFC->streams[i]->codec->codec_id == CODEC_ID_MP2)
                 {
@@ -1397,8 +1447,14 @@
                 }
                 if (delta < 0 && af->count() > 1)
                 {
-                    if (cmp2x33(af->next()->pkt.pts,
-                                vFrame.first()->pkt.pts) > 0)
+		    int aud_cmp = cmp2x33(af->next()->pkt.pts, vFrame.first()->pkt.pts);
+
+                    VERBOSE(MPF_PROCESS,
+                                QString("Looking for A packet from stream %1  delta %2 cmp2x33 %3")
+                                        .arg(it.key()).arg(delta).arg(aud_cmp));
+                    //if (cmp2x33(af->next()->pkt.pts,
+                    //            vFrame.first()->pkt.pts) > 0)
+		    if (aud_cmp > 0)
                     {
                         VERBOSE(MPF_PROCESS, QString("Found useful audio "
                                 "frame from stream %1").arg(it.key()));
@@ -1408,7 +1464,7 @@
                     else
                     {
                         VERBOSE(MPF_PROCESS,
-                                QString("Dropping A packet from stream %1")
+                                QString("2 Dropping A packet from stream %1")
                                        .arg(it.key()));
                         framePool.enqueue( af->first());
                         af->removeFirst();
@@ -1859,10 +1915,10 @@
     {
         Q3PtrList<MPEG2frame> *af = &it.data();
         deltaPTS = diff2x33(vFrame.current()->pkt.pts, af->first()->pkt.pts);
-        VERBOSE(MPF_GENERAL, QString("#%1 PTS:%2 Delta: %3ms queue: %4")
+        VERBOSE(MPF_GENERAL, QString("#%1 PTS:%2 Delta: %3ms queue: %4 initPTS: %5")
                              .arg(it.key())
                              .arg(PtsTime(af->current()->pkt.pts))
-                             .arg(1000.0*deltaPTS / 90000.0).arg(af->count()));
+                             .arg(1000.0*deltaPTS / 90000.0).arg(af->count()).arg(PtsTime(initPTS)));
 
         if (cmp2x33(af->current()->pkt.pts, initPTS) < 0)
             initPTS = af->current()->pkt.pts;
@@ -1971,9 +2027,11 @@
                 // beforehand
                 if (PTSdiscrep && ! file_end)
                 {
+                    VERBOSE(MPF_IMPORTANT, QString("Detected PTS Discrepency "));
+
                     int pos = vFrame.count();
                     int count = Lreorder.count();
-                    while (vFrame.count() - frame_pos - count < 20 && !file_end)
+                    while (vFrame.count() - frame_pos - count < 40 && !file_end)
                         if ((ret = GetFrame(&pkt)) < 0)
                             return ret;
                     if (! file_end)
@@ -1995,6 +2053,7 @@
                                            tmpPTSdiscrep, numframes, false);
                                 if (!tmpPTSdiscrep)
                                 {
+                                    VERBOSE(MPF_IMPORTANT, QString("Fixed a temporary PTS discrepency, moving on... "));
                                     //discrepancy was short-lived, continue on
                                     done = true;
                                     PTSdiscrep = 0;
@@ -2003,6 +2062,7 @@
                                 if (tmpPTSdiscrep != (int64_t)AV_NOPTS_VALUE &&
                                     tmpPTSdiscrep != PTSdiscrep)
                                     PTSdiscrep = tmpPTSdiscrep;
+                                    VERBOSE(MPF_IMPORTANT, QString("Severe PTS discrepency, deadlock imminent... "));
                             }
                             count += tmpReorder.count();
                         }
Index: main.cpp
===================================================================
--- main.cpp	(revision 18755)
+++ main.cpp	(working copy)
@@ -363,7 +363,7 @@
                 if(!strcmp(a.argv()[argpos + 1], "dvd"))
                     otype = REPLEX_DVD;
                 if(!strcmp(a.argv()[argpos + 1], "ts"))
-                    otype = REPLEX_TS_SD;
+                    otype = REPLEX_HDTV;
 
                 ++argpos;
             }
Index: mpeg2fix.h
===================================================================
--- mpeg2fix.h	(revision 18755)
+++ mpeg2fix.h	(working copy)
@@ -113,15 +113,19 @@
     int otype;
     ringbuffer vrbuf;
     ringbuffer extrbuf[N_AUDIO];
+    ringbuffer ac3extrbuf[N_AUDIO];
     ringbuffer index_vrbuf;
     ringbuffer index_extrbuf[N_AUDIO];
+    ringbuffer index_ac3extrbuf[N_AUDIO];
     int ext_count;
+    int ac3_count;
     int exttype[N_AUDIO];
     int exttypcnt[N_AUDIO];
 
     pthread_mutex_t mutex;
     pthread_cond_t cond;
     audio_frame_t extframe[N_AUDIO];
+    audio_frame_t ac3frame[N_AC3];
     sequence_t seq_head;
 
   private:
@@ -235,6 +239,7 @@
     AVFormatContext *inputFC;
     int vid_id;
     int ext_count;
+    int ac3_count;
     QMap <int, int> aud_map;
     int aud_stream_count;
     int64_t ptsIncrement;
